<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- font -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <title>Document</title>
</head>
<body onload="onPageLoading()">
    <div class="container-fluid">
        <h2 class="text-center">Danh sách đơn hàng</h2>
        <button class="btn btn-success mt-2" onclick="onBtnCreateOrderClick()">Thêm đơn hàng</button>
        <table class="table table-bordered table-hover table-striped" id="table-order">
            <thead>
                <tr>
                  <th>Order Code</th>
                  <th>Kích cỡ combo</th>
                  <th>Loại Pizza</th>
                  <th>Nước uống</th>
                  <th>Thành tiền</th>
                  <th>Họ và tên</th>
                  <th>Số điện thoại</th>
                  <th>Trạng thái</th>
                  <th>Chi tiết</th>
                </tr>
              </thead>
              <tbody>
        
              </tbody>
        </table>

    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */ 
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const gEND_ROW_TABLE = -1;
    const gCOL_ORDER_CODE = 0;
    const gCOL_SIZE_COMBO = 1;
    const gCOL_TYPE_PIZZA = 2;
    const gCOL_DRINKS = 3;
    const gCOL_COST = 4;
    const gCOL_FULLNAME = 5;
    const gCOL_PHONE = 6;
    const gCOL_STATUS = 7;
    const gCOL_ORDER_DETAIL = 8;
    

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        getAllOrders();
    }
    function onBtnOrderDetailClick(paramOrderDetailClick){
        //lay du lieu dataset
        var vID = paramOrderDetailClick.getAttribute("data-id");
        var vOrderCode = paramOrderDetailClick.getAttribute("data-orderCode");
        //send data vao console
        console.log("Id: " + vID);
        console.log("Order Code: " + vOrderCode);
    }
    ////hàm xử lý nút thêm đơn hàng được click
    function onBtnCreateOrderClick(){
        "use strict";
        const vCREATE_ORDER_FORM_URL = "create.order.html";
        var vUrlSiteToOpen = vCREATE_ORDER_FORM_URL;
        window.location.href = vUrlSiteToOpen;
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //ham load all order len table
    function getAllOrders(){
        //b3 goi api tu server
        var vXmlHttp = new XMLHttpRequest();
        callApiToGetAllOrders(vXmlHttp);
        //b4 xu ly tren frontend khi request xu ly va tra ve response thanh cong
        vXmlHttp.onreadystatechange = function(){
            if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                loadOrderToTable(vXmlHttp);
            }
        }
    }
    //ham goi api de lay all order
    function callApiToGetAllOrders(paramXmlHttp){
        paramXmlHttp.open("GET",gBASE_URL,true);
        paramXmlHttp.send();
    }
    function loadOrderToTable(paramXmlHttp){
        //ghi responseText ra console log
        console.log(paramXmlHttp.responseText);
        //parse du lieu sang object
        var vAllOrderObj = JSON.parse(paramXmlHttp.responseText);
        var vOrderTable = document.getElementById("table-order");
        var vOrderTableBody = document.getElementsByTagName("tbody")[0];
        //them dong du lieu vao tbody
        for(var bI = 0; bI<vAllOrderObj.length; bI++){
            //them dong
            var bNewOrderRow = vOrderTableBody.insertRow(gEND_ROW_TABLE);
            //them tung o 
            var bOrderCodeCell = bNewOrderRow.insertCell(gCOL_ORDER_CODE);
            var bComboSizeCell = bNewOrderRow.insertCell(gCOL_SIZE_COMBO);
            var bPizzaTypeCell = bNewOrderRow.insertCell(gCOL_TYPE_PIZZA);
            var bDrinkCell = bNewOrderRow.insertCell(gCOL_DRINKS);
            var bTotalAmountCell = bNewOrderRow.insertCell(gCOL_COST);
            var bFullNameCell = bNewOrderRow.insertCell(gCOL_FULLNAME);
            var bPhoneCell = bNewOrderRow.insertCell(gCOL_PHONE);
            var bStatusCell = bNewOrderRow.insertCell(gCOL_STATUS);
            var bOrderDetailCell = bNewOrderRow.insertCell(gCOL_ORDER_DETAIL);

            //them du lieu tung cell 
            bOrderCodeCell.innerHTML = vAllOrderObj[bI].orderCode;
            bComboSizeCell.innerHTML = vAllOrderObj[bI].kichCo;
            bPizzaTypeCell.innerHTML = vAllOrderObj[bI].loaiPizza;
            bDrinkCell.innerHTML = vAllOrderObj[bI].idLoaiNuocUong;
            bTotalAmountCell.innerHTML = vAllOrderObj[bI].thanhTien;
            bFullNameCell.innerHTML = vAllOrderObj[bI].hoTen;
            bPhoneCell.innerHTML = vAllOrderObj[bI].soDienThoai;
            bStatusCell.innerHTML = vAllOrderObj[bI].trangThai;
            //them nut chi tiet
            var bDetailButton = document.createElement("button");
            bDetailButton.textContent = "Chi tiết";
            bDetailButton.className = "btn btn-info order-detail";
            bDetailButton.setAttribute("data-id",vAllOrderObj[bI].id);
            bDetailButton.setAttribute("data-ordercode", vAllOrderObj[bI].orderCode);
            bOrderDetailCell.appendChild(bDetailButton);
            bDetailButton.addEventListener("click", function(){
                onBtnOrderDetailClick(this);
            });
        }
    }
</script>
</html>